<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ObtieneRelacionadosCFDICA StructType
 * Meta information extracted from the WSDL
 * - type: tns:ObtieneRelacionadosCFDICA
 * @subpackage Structs
 */
class ObtieneRelacionadosCFDICA extends AbstractStructBase
{
    /**
     * The usuario
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $usuario;
    /**
     * The contrasenia
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $contrasenia;
    /**
     * The idServicio
     * @var int
     */
    public $idServicio;
    /**
     * The RfcReceptor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $RfcReceptor;
    /**
     * The UUID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $UUID;
    /**
     * Constructor method for ObtieneRelacionadosCFDICA
     * @uses ObtieneRelacionadosCFDICA::setUsuario()
     * @uses ObtieneRelacionadosCFDICA::setContrasenia()
     * @uses ObtieneRelacionadosCFDICA::setIdServicio()
     * @uses ObtieneRelacionadosCFDICA::setRfcReceptor()
     * @uses ObtieneRelacionadosCFDICA::setUUID()
     * @param string $usuario
     * @param string $contrasenia
     * @param int $idServicio
     * @param string $rfcReceptor
     * @param string $uUID
     */
    public function __construct($usuario = null, $contrasenia = null, $idServicio = null, $rfcReceptor = null, $uUID = null)
    {
        $this
            ->setUsuario($usuario)
            ->setContrasenia($contrasenia)
            ->setIdServicio($idServicio)
            ->setRfcReceptor($rfcReceptor)
            ->setUUID($uUID);
    }
    /**
     * Get usuario value
     * @return string|null
     */
    public function getUsuario()
    {
        return $this->usuario;
    }
    /**
     * Set usuario value
     * @param string $usuario
     * @return \StructType\ObtieneRelacionadosCFDICA
     */
    public function setUsuario($usuario = null)
    {
        // validation for constraint: string
        if (!is_null($usuario) && !is_string($usuario)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($usuario, true), gettype($usuario)), __LINE__);
        }
        $this->usuario = $usuario;
        return $this;
    }
    /**
     * Get contrasenia value
     * @return string|null
     */
    public function getContrasenia()
    {
        return $this->contrasenia;
    }
    /**
     * Set contrasenia value
     * @param string $contrasenia
     * @return \StructType\ObtieneRelacionadosCFDICA
     */
    public function setContrasenia($contrasenia = null)
    {
        // validation for constraint: string
        if (!is_null($contrasenia) && !is_string($contrasenia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contrasenia, true), gettype($contrasenia)), __LINE__);
        }
        $this->contrasenia = $contrasenia;
        return $this;
    }
    /**
     * Get idServicio value
     * @return int|null
     */
    public function getIdServicio()
    {
        return $this->idServicio;
    }
    /**
     * Set idServicio value
     * @param int $idServicio
     * @return \StructType\ObtieneRelacionadosCFDICA
     */
    public function setIdServicio($idServicio = null)
    {
        // validation for constraint: int
        if (!is_null($idServicio) && !(is_int($idServicio) || ctype_digit($idServicio))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($idServicio, true), gettype($idServicio)), __LINE__);
        }
        $this->idServicio = $idServicio;
        return $this;
    }
    /**
     * Get RfcReceptor value
     * @return string|null
     */
    public function getRfcReceptor()
    {
        return $this->RfcReceptor;
    }
    /**
     * Set RfcReceptor value
     * @param string $rfcReceptor
     * @return \StructType\ObtieneRelacionadosCFDICA
     */
    public function setRfcReceptor($rfcReceptor = null)
    {
        // validation for constraint: string
        if (!is_null($rfcReceptor) && !is_string($rfcReceptor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rfcReceptor, true), gettype($rfcReceptor)), __LINE__);
        }
        $this->RfcReceptor = $rfcReceptor;
        return $this;
    }
    /**
     * Get UUID value
     * @return string|null
     */
    public function getUUID()
    {
        return $this->UUID;
    }
    /**
     * Set UUID value
     * @param string $uUID
     * @return \StructType\ObtieneRelacionadosCFDICA
     */
    public function setUUID($uUID = null)
    {
        // validation for constraint: string
        if (!is_null($uUID) && !is_string($uUID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uUID, true), gettype($uUID)), __LINE__);
        }
        $this->UUID = $uUID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ObtieneRelacionadosCFDICA
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
