<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for wsResponsePendientesBO StructType
 * @subpackage Structs
 */
class WsResponsePendientesBO extends AbstractStructBase
{
    /**
     * The codigoError
     * @var int
     */
    public $codigoError;
    /**
     * The isError
     * @var bool
     */
    public $isError;
    /**
     * The mensaje
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mensaje;
    /**
     * The pendientes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pendientes;
    /**
     * The status
     * @var int
     */
    public $status;
    /**
     * Constructor method for wsResponsePendientesBO
     * @uses WsResponsePendientesBO::setCodigoError()
     * @uses WsResponsePendientesBO::setIsError()
     * @uses WsResponsePendientesBO::setMensaje()
     * @uses WsResponsePendientesBO::setPendientes()
     * @uses WsResponsePendientesBO::setStatus()
     * @param int $codigoError
     * @param bool $isError
     * @param string $mensaje
     * @param string $pendientes
     * @param int $status
     */
    public function __construct($codigoError = null, $isError = null, $mensaje = null, $pendientes = null, $status = null)
    {
        $this
            ->setCodigoError($codigoError)
            ->setIsError($isError)
            ->setMensaje($mensaje)
            ->setPendientes($pendientes)
            ->setStatus($status);
    }
    /**
     * Get codigoError value
     * @return int|null
     */
    public function getCodigoError()
    {
        return $this->codigoError;
    }
    /**
     * Set codigoError value
     * @param int $codigoError
     * @return \StructType\WsResponsePendientesBO
     */
    public function setCodigoError($codigoError = null)
    {
        // validation for constraint: int
        if (!is_null($codigoError) && !(is_int($codigoError) || ctype_digit($codigoError))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codigoError, true), gettype($codigoError)), __LINE__);
        }
        $this->codigoError = $codigoError;
        return $this;
    }
    /**
     * Get isError value
     * @return bool|null
     */
    public function getIsError()
    {
        return $this->isError;
    }
    /**
     * Set isError value
     * @param bool $isError
     * @return \StructType\WsResponsePendientesBO
     */
    public function setIsError($isError = null)
    {
        // validation for constraint: boolean
        if (!is_null($isError) && !is_bool($isError)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isError, true), gettype($isError)), __LINE__);
        }
        $this->isError = $isError;
        return $this;
    }
    /**
     * Get mensaje value
     * @return string|null
     */
    public function getMensaje()
    {
        return $this->mensaje;
    }
    /**
     * Set mensaje value
     * @param string $mensaje
     * @return \StructType\WsResponsePendientesBO
     */
    public function setMensaje($mensaje = null)
    {
        // validation for constraint: string
        if (!is_null($mensaje) && !is_string($mensaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mensaje, true), gettype($mensaje)), __LINE__);
        }
        $this->mensaje = $mensaje;
        return $this;
    }
    /**
     * Get pendientes value
     * @return string|null
     */
    public function getPendientes()
    {
        return $this->pendientes;
    }
    /**
     * Set pendientes value
     * @param string $pendientes
     * @return \StructType\WsResponsePendientesBO
     */
    public function setPendientes($pendientes = null)
    {
        // validation for constraint: string
        if (!is_null($pendientes) && !is_string($pendientes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pendientes, true), gettype($pendientes)), __LINE__);
        }
        $this->pendientes = $pendientes;
        return $this;
    }
    /**
     * Get status value
     * @return int|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param int $status
     * @return \StructType\WsResponsePendientesBO
     */
    public function setStatus($status = null)
    {
        // validation for constraint: int
        if (!is_null($status) && !(is_int($status) || ctype_digit($status))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WsResponsePendientesBO
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
